]> CyberLeo.Net >> Repos - FreeBSD/stable/8.git/blob - etc/rc.subr
MFC r197297
[FreeBSD/stable/8.git] / etc / rc.subr
1 # $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2 # $FreeBSD$
3 #
4 # Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5 # All rights reserved.
6 #
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Luke Mewburn.
9 #
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
12 # are met:
13 # 1. Redistributions of source code must retain the above copyright
14 #    notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 #    notice, this list of conditions and the following disclaimer in the
17 #    documentation and/or other materials provided with the distribution.
18 # 3. All advertising materials mentioning features or use of this software
19 #    must display the following acknowledgement:
20 #        This product includes software developed by the NetBSD
21 #        Foundation, Inc. and its contributors.
22 # 4. Neither the name of The NetBSD Foundation nor the names of its
23 #    contributors may be used to endorse or promote products derived
24 #    from this software without specific prior written permission.
25 #
26 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
27 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
28 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
29 # PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
30 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
31 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
32 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
33 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
34 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
35 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
36 # POSSIBILITY OF SUCH DAMAGE.
37 #
38 # rc.subr
39 #       functions used by various rc scripts
40 #
41
42 : ${rcvar_manpage:='rc.conf(5)'}
43 : ${RC_PID:=$$}; export RC_PID
44
45 #
46 #       Operating System dependent/independent variables
47 #
48
49 if [ -z "${_rc_subr_loaded}" ]; then
50
51 _rc_subr_loaded="YES"
52
53 SYSCTL="/sbin/sysctl"
54 SYSCTL_N="${SYSCTL} -n"
55 CMD_OSTYPE="${SYSCTL_N} kern.ostype"
56 OSTYPE=`${CMD_OSTYPE}`
57 ID="/usr/bin/id"
58 IDCMD="if [ -x $ID ]; then $ID -un; fi"
59 PS="/bin/ps -ww"
60 JID=`$PS -p $$ -o jid=`
61
62 case ${OSTYPE} in
63 FreeBSD)
64         SYSCTL_W="${SYSCTL}"
65         ;;
66 NetBSD)
67         SYSCTL_W="${SYSCTL} -w"
68         ;;
69 esac
70
71 #
72 #       functions
73 #       ---------
74
75 #
76 # set_rcvar base_var
77 #       Set the variable name enabling a specific service.
78 #       FreeBSD uses ${service}_enable, while NetBSD uses
79 #       just the name of the service. For example:
80 #       FreeBSD: sendmail_enable="YES"
81 #       NetBSD : sendmail="YES"
82 #       $1 - if $name is not the base to work of off, specify
83 #            a different one
84 #
85 set_rcvar()
86 {
87         if [ -z "$1" ]; then
88                 base_var=${name}
89         else
90                 base_var="$1"
91         fi
92
93         case ${OSTYPE} in
94         FreeBSD)
95                 echo ${base_var}_enable
96                 ;;
97         NetBSD)
98                 echo ${base_var}
99                 ;;
100         *)
101                 echo 'XXX'
102                 ;;
103         esac
104 }
105
106 #
107 # force_depend script
108 #       Force a service to start. Intended for use by services
109 #       to resolve dependency issues. It is assumed the caller
110 #       has check to make sure this call is necessary
111 #       $1 - filename of script, in /etc/rc.d, to run
112 #
113 force_depend()
114 {
115         _depend="$1"
116
117         info "${name} depends on ${_depend}, which will be forced to start."
118         if ! /etc/rc.d/${_depend} forcestart; then
119                 warn "Unable to force ${_depend}. It may already be running."
120                 return 1
121         fi
122         return 0
123 }
124
125 #
126 # checkyesno var
127 #       Test $1 variable, and warn if not set to YES or NO.
128 #       Return 0 if it's "yes" (et al), nonzero otherwise.
129 #
130 checkyesno()
131 {
132         eval _value=\$${1}
133         debug "checkyesno: $1 is set to $_value."
134         case $_value in
135
136                 #       "yes", "true", "on", or "1"
137         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
138                 return 0
139                 ;;
140
141                 #       "no", "false", "off", or "0"
142         [Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
143                 return 1
144                 ;;
145         *)
146                 warn "\$${1} is not set properly - see ${rcvar_manpage}."
147                 return 1
148                 ;;
149         esac
150 }
151
152 #
153 # reverse_list list
154 #       print the list in reverse order
155 #
156 reverse_list()
157 {
158         _revlist=
159         for _revfile; do
160                 _revlist="$_revfile $_revlist"
161         done
162         echo $_revlist
163 }
164
165 # stop_boot always
166 #       If booting directly to multiuser or $always is enabled,
167 #       send SIGTERM to the parent (/etc/rc) to abort the boot.
168 #       Otherwise just exit.
169 #
170 stop_boot()
171 {
172         local always
173
174         case $1 in
175                 #       "yes", "true", "on", or "1"
176         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
177                 always=true
178                 ;;
179         *)
180                 always=false
181                 ;;
182         esac
183         if [ "$autoboot" = yes -o "$always" = true ]; then
184                 echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
185                 kill -TERM ${RC_PID}
186         fi
187         exit 1
188 }
189
190 #
191 # mount_critical_filesystems type
192 #       Go through the list of critical filesystems as provided in
193 #       the rc.conf(5) variable $critical_filesystems_${type}, checking
194 #       each one to see if it is mounted, and if it is not, mounting it.
195 #
196 mount_critical_filesystems()
197 {
198         eval _fslist=\$critical_filesystems_${1}
199         for _fs in $_fslist; do
200                 mount | (
201                         _ismounted=false
202                         while read what _on on _type type; do
203                                 if [ $on = $_fs ]; then
204                                         _ismounted=true
205                                 fi
206                         done
207                         if $_ismounted; then
208                                 :
209                         else
210                                 mount $_fs >/dev/null 2>&1
211                         fi
212                 )
213         done
214 }
215
216 #
217 # check_pidfile pidfile procname [interpreter]
218 #       Parses the first line of pidfile for a PID, and ensures
219 #       that the process is running and matches procname.
220 #       Prints the matching PID upon success, nothing otherwise.
221 #       interpreter is optional; see _find_processes() for details.
222 #
223 check_pidfile()
224 {
225         _pidfile=$1
226         _procname=$2
227         _interpreter=$3
228         if [ -z "$_pidfile" -o -z "$_procname" ]; then
229                 err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
230         fi
231         if [ ! -f $_pidfile ]; then
232                 debug "pid file ($_pidfile): not readable."
233                 return
234         fi
235         read _pid _junk < $_pidfile
236         if [ -z "$_pid" ]; then
237                 debug "pid file ($_pidfile): no pid in file."
238                 return
239         fi
240         _find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
241 }
242
243 #
244 # check_process procname [interpreter]
245 #       Ensures that a process (or processes) named procname is running.
246 #       Prints a list of matching PIDs.
247 #       interpreter is optional; see _find_processes() for details.
248 #
249 check_process()
250 {
251         _procname=$1
252         _interpreter=$2
253         if [ -z "$_procname" ]; then
254                 err 3 'USAGE: check_process procname [interpreter]'
255         fi
256         _find_processes $_procname ${_interpreter:-.} '-ax'
257 }
258
259 #
260 # _find_processes procname interpreter psargs
261 #       Search for procname in the output of ps generated by psargs.
262 #       Prints the PIDs of any matching processes, space separated.
263 #
264 #       If interpreter == ".", check the following variations of procname
265 #       against the first word of each command:
266 #               procname
267 #               `basename procname`
268 #               `basename procname` + ":"
269 #               "(" + `basename procname` + ")"
270 #               "[" + `basename procname` + "]"
271 #
272 #       If interpreter != ".", read the first line of procname, remove the
273 #       leading #!, normalise whitespace, append procname, and attempt to
274 #       match that against each command, either as is, or with extra words
275 #       at the end.  As an alternative, to deal with interpreted daemons
276 #       using perl, the basename of the interpreter plus a colon is also
277 #       tried as the prefix to procname.
278 #
279 _find_processes()
280 {
281         if [ $# -ne 3 ]; then
282                 err 3 'USAGE: _find_processes procname interpreter psargs'
283         fi
284         _procname=$1
285         _interpreter=$2
286         _psargs=$3
287
288         _pref=
289         if [ $_interpreter != "." ]; then       # an interpreted script
290                 _script=${_chroot}${_chroot:+"/"}$_procname
291                 if [ -r $_script ]; then
292                         read _interp < $_script # read interpreter name
293                         case "$_interp" in
294                         \#!*)
295                                 _interp=${_interp#\#!}  # strip #!
296                                 set -- $_interp
297                                 case $1 in
298                                 */bin/env)
299                                         shift   # drop env to get real name
300                                         ;;
301                                 esac
302                                 if [ $_interpreter != $1 ]; then
303                                         warn "\$command_interpreter $_interpreter != $1"
304                                 fi
305                                 ;;
306                         *)
307                                 warn "no shebang line in $_script"
308                                 set -- $_interpreter
309                                 ;;
310                         esac
311                 else
312                         warn "cannot read shebang line from $_script"
313                         set -- $_interpreter
314                 fi
315                 _interp="$* $_procname"         # cleanup spaces, add _procname
316                 _interpbn=${1##*/}
317                 _fp_args='_argv'
318                 _fp_match='case "$_argv" in
319                     ${_interp}|"${_interp} "*|"${_interpbn}: ${_procname}"*)'
320         else                                    # a normal daemon
321                 _procnamebn=${_procname##*/}
322                 _fp_args='_arg0 _argv'
323                 _fp_match='case "$_arg0" in
324                     $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
325         fi
326
327         _proccheck="\
328                 $PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
329                 while read _npid _jid '"$_fp_args"'; do
330                         '"$_fp_match"'
331                                 if [ "$JID" -eq "$_jid" ];
332                                 then echo -n "$_pref$_npid";
333                                 _pref=" ";
334                                 fi
335                                 ;;
336                         esac
337                 done'
338
339 #       debug "in _find_processes: proccheck is ($_proccheck)."
340         eval $_proccheck
341 }
342
343 #
344 # wait_for_pids pid [pid ...]
345 #       spins until none of the pids exist
346 #
347 wait_for_pids()
348 {
349         _list="$@"
350         if [ -z "$_list" ]; then
351                 return
352         fi
353         _prefix=
354         while true; do
355                 _nlist="";
356                 for _j in $_list; do
357                         if kill -0 $_j 2>/dev/null; then
358                                 _nlist="${_nlist}${_nlist:+ }$_j"
359                         fi
360                 done
361                 if [ -z "$_nlist" ]; then
362                         break
363                 fi
364                 _list=$_nlist
365                 echo -n ${_prefix:-"Waiting for PIDS: "}$_list
366                 _prefix=", "
367                 sleep 2
368         done
369         if [ -n "$_prefix" ]; then
370                 echo "."
371         fi
372 }
373
374 #
375 # run_rc_command argument
376 #       Search for argument in the list of supported commands, which is:
377 #               "start stop restart rcvar status poll ${extra_commands}"
378 #       If there's a match, run ${argument}_cmd or the default method
379 #       (see below).
380 #
381 #       If argument has a given prefix, then change the operation as follows:
382 #               Prefix  Operation
383 #               ------  ---------
384 #               fast    Skip the pid check, and set rc_fast=yes, rc_quiet=yes
385 #               force   Set ${rcvar} to YES, and set rc_force=yes
386 #               one     Set ${rcvar} to YES
387 #               quiet   Don't output some diagnostics, and set rc_quiet=yes
388 #
389 #       The following globals are used:
390 #
391 #       Name            Needed  Purpose
392 #       ----            ------  -------
393 #       name            y       Name of script.
394 #
395 #       command         n       Full path to command.
396 #                               Not needed if ${rc_arg}_cmd is set for
397 #                               each keyword.
398 #
399 #       command_args    n       Optional args/shell directives for command.
400 #
401 #       command_interpreter n   If not empty, command is interpreted, so
402 #                               call check_{pidfile,process}() appropriately.
403 #
404 #       extra_commands  n       List of extra commands supported.
405 #
406 #       pidfile         n       If set, use check_pidfile $pidfile $command,
407 #                               otherwise use check_process $command.
408 #                               In either case, only check if $command is set.
409 #
410 #       procname        n       Process name to check for instead of $command.
411 #
412 #       rcvar           n       This is checked with checkyesno to determine
413 #                               if the action should be run.
414 #
415 #       ${name}_program n       Full path to command.
416 #                               Meant to be used in /etc/rc.conf to override
417 #                               ${command}.
418 #
419 #       ${name}_chroot  n       Directory to chroot to before running ${command}
420 #                               Requires /usr to be mounted.
421 #
422 #       ${name}_chdir   n       Directory to cd to before running ${command}
423 #                               (if not using ${name}_chroot).
424 #
425 #       ${name}_flags   n       Arguments to call ${command} with.
426 #                               NOTE:   $flags from the parent environment
427 #                                       can be used to override this.
428 #
429 #       ${name}_nice    n       Nice level to run ${command} at.
430 #
431 #       ${name}_user    n       User to run ${command} as, using su(1) if not
432 #                               using ${name}_chroot.
433 #                               Requires /usr to be mounted.
434 #
435 #       ${name}_group   n       Group to run chrooted ${command} as.
436 #                               Requires /usr to be mounted.
437 #
438 #       ${name}_groups  n       Comma separated list of supplementary groups
439 #                               to run the chrooted ${command} with.
440 #                               Requires /usr to be mounted.
441 #
442 #       ${rc_arg}_cmd   n       If set, use this as the method when invoked;
443 #                               Otherwise, use default command (see below)
444 #
445 #       ${rc_arg}_precmd n      If set, run just before performing the
446 #                               ${rc_arg}_cmd method in the default
447 #                               operation (i.e, after checking for required
448 #                               bits and process (non)existence).
449 #                               If this completes with a non-zero exit code,
450 #                               don't run ${rc_arg}_cmd.
451 #
452 #       ${rc_arg}_postcmd n     If set, run just after performing the
453 #                               ${rc_arg}_cmd method, if that method
454 #                               returned a zero exit code.
455 #
456 #       required_dirs   n       If set, check for the existence of the given
457 #                               directories before running a (re)start command.
458 #
459 #       required_files  n       If set, check for the readability of the given
460 #                               files before running a (re)start command.
461 #
462 #       required_modules n      If set, ensure the given kernel modules are
463 #                               loaded before running a (re)start command.
464 #                               The check and possible loads are actually
465 #                               done after start_precmd so that the modules
466 #                               aren't loaded in vain, should the precmd
467 #                               return a non-zero status to indicate a error.
468 #                               If a word in the list looks like "foo:bar",
469 #                               "foo" is the KLD file name and "bar" is the
470 #                               module name.  If a word looks like "foo~bar",
471 #                               "foo" is the KLD file name and "bar" is a
472 #                               egrep(1) pattern matching the module name.
473 #                               Otherwise the module name is assumed to be
474 #                               the same as the KLD file name, which is most
475 #                               common.  See load_kld().
476 #
477 #       required_vars   n       If set, perform checkyesno on each of the
478 #                               listed variables before running the default
479 #                               (re)start command.
480 #
481 #       Default behaviour for a given argument, if no override method is
482 #       provided:
483 #
484 #       Argument        Default behaviour
485 #       --------        -----------------
486 #       start           if !running && checkyesno ${rcvar}
487 #                               ${command}
488 #
489 #       stop            if ${pidfile}
490 #                               rc_pid=$(check_pidfile $pidfile $command)
491 #                       else
492 #                               rc_pid=$(check_process $command)
493 #                       kill $sig_stop $rc_pid
494 #                       wait_for_pids $rc_pid
495 #                       ($sig_stop defaults to TERM.)
496 #
497 #       reload          Similar to stop, except use $sig_reload instead,
498 #                       and doesn't wait_for_pids.
499 #                       $sig_reload defaults to HUP.
500 #                       Note that `reload' isn't provided by default,
501 #                       it should be enabled via $extra_commands.
502 #
503 #       restart         Run `stop' then `start'.
504 #
505 #       status          Show if ${command} is running, etc.
506 #
507 #       poll            Wait for ${command} to exit.
508 #
509 #       rcvar           Display what rc.conf variable is used (if any).
510 #
511 #       Variables available to methods, and after run_rc_command() has
512 #       completed:
513 #
514 #       Variable        Purpose
515 #       --------        -------
516 #       rc_arg          Argument to command, after fast/force/one processing
517 #                       performed
518 #
519 #       rc_flags        Flags to start the default command with.
520 #                       Defaults to ${name}_flags, unless overridden
521 #                       by $flags from the environment.
522 #                       This variable may be changed by the precmd method.
523 #
524 #       rc_pid          PID of command (if appropriate)
525 #
526 #       rc_fast         Not empty if "fast" was provided (q.v.)
527 #
528 #       rc_force        Not empty if "force" was provided (q.v.)
529 #
530 #       rc_quiet        Not empty if "quiet" was provided
531 #
532 #
533 run_rc_command()
534 {
535         _return=0
536         rc_arg=$1
537         if [ -z "$name" ]; then
538                 err 3 'run_rc_command: $name is not set.'
539         fi
540
541         # Don't repeat the first argument when passing additional command-
542         # line arguments to the command subroutines.
543         #
544         shift 1
545         rc_extra_args="$*"
546
547         _rc_prefix=
548         case "$rc_arg" in
549         fast*)                          # "fast" prefix; don't check pid
550                 rc_arg=${rc_arg#fast}
551                 rc_fast=yes
552                 rc_quiet=yes
553                 ;;
554         force*)                         # "force prefix; always run
555                 rc_force=yes
556                 _rc_prefix=force
557                 rc_arg=${rc_arg#${_rc_prefix}}
558                 if [ -n "${rcvar}" ]; then
559                         eval ${rcvar}=YES
560                 fi
561                 ;;
562         one*)                           # "one" prefix; set ${rcvar}=yes
563                 _rc_prefix=one
564                 rc_arg=${rc_arg#${_rc_prefix}}
565                 if [ -n "${rcvar}" ]; then
566                         eval ${rcvar}=YES
567                 fi
568                 ;;
569         quiet*)                         # "quiet" prefix; omit some messages
570                 _rc_prefix=quiet
571                 rc_arg=${rc_arg#${_rc_prefix}}
572                 rc_quiet=yes
573                 ;;
574         esac
575
576         eval _override_command=\$${name}_program
577         command=${command:+${_override_command:-$command}}
578
579         _keywords="start stop restart rcvar $extra_commands"
580         rc_pid=
581         _pidcmd=
582         _procname=${procname:-${command}}
583
584                                         # setup pid check command
585         if [ -n "$_procname" ]; then
586                 if [ -n "$pidfile" ]; then
587                         _pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
588                 else
589                         _pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
590                 fi
591                 if [ -n "$_pidcmd" ]; then
592                         _keywords="${_keywords} status poll"
593                 fi
594         fi
595
596         if [ -z "$rc_arg" ]; then
597                 rc_usage $_keywords
598         fi
599
600         if [ -n "$flags" ]; then        # allow override from environment
601                 rc_flags=$flags
602         else
603                 eval rc_flags=\$${name}_flags
604         fi
605         eval _chdir=\$${name}_chdir     _chroot=\$${name}_chroot \
606             _nice=\$${name}_nice        _user=\$${name}_user \
607             _group=\$${name}_group      _groups=\$${name}_groups
608
609         if [ -n "$_user" ]; then        # unset $_user if running as that user
610                 if [ "$_user" = "$(eval $IDCMD)" ]; then
611                         unset _user
612                 fi
613         fi
614
615         eval $_pidcmd                   # determine the pid if necessary
616
617         for _elem in $_keywords; do
618                 if [ "$_elem" != "$rc_arg" ]; then
619                         continue
620                 fi
621                                         # if ${rcvar} is set, and $1 is not
622                                         # "rcvar", then run
623                                         #       checkyesno ${rcvar}
624                                         # and return if that failed
625                                         #
626                 if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" ]; then
627                         if ! checkyesno ${rcvar}; then
628                                 if [ -n "${rc_quiet}" ]; then
629                                         return 0
630                                 fi
631                                 echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
632                                 echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
633                                 echo "instead of '${rc_arg}'."
634                                 return 0
635                         fi
636                 fi
637
638                                         # if there's a custom ${XXX_cmd},
639                                         # run that instead of the default
640                                         #
641                 eval _cmd=\$${rc_arg}_cmd \
642                      _precmd=\$${rc_arg}_precmd \
643                      _postcmd=\$${rc_arg}_postcmd
644
645                 if [ -n "$_cmd" ]; then
646                         _run_rc_precmd || return 1
647                         _run_rc_doit "$_cmd $rc_extra_args" || return 1
648                         _run_rc_postcmd
649                         return $_return
650                 fi
651
652                 case "$rc_arg" in       # default operations...
653
654                 status)
655                         _run_rc_precmd || return 1
656                         if [ -n "$rc_pid" ]; then
657                                 echo "${name} is running as pid $rc_pid."
658                         else
659                                 echo "${name} is not running."
660                                 return 1
661                         fi
662                         _run_rc_postcmd
663                         ;;
664
665                 start)
666                         if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
667                                 echo 1>&2 "${name} already running? (pid=$rc_pid)."
668                                 return 1
669                         fi
670
671                         if [ ! -x ${_chroot}${_chroot:+"/"}${command} ]; then
672                                 warn "run_rc_command: cannot run $command"
673                                 return 1
674                         fi
675
676                         if ! _run_rc_precmd; then
677                                 warn "failed precmd routine for ${name}"
678                                 return 1
679                         fi
680
681                                         # setup the full command to run
682                                         #
683                         _show_startmsgs=1
684                         if [ -n "${rc_quiet}" ]; then
685                                 if ! checkyesno rc_startmsgs; then
686                                         unset _show_startmsgs
687                                 fi
688                         fi
689                         [ -n "$_show_startmsgs" ] && echo "Starting ${name}."
690                         if [ -n "$_chroot" ]; then
691                                 _doit="\
692 ${_nice:+nice -n $_nice }\
693 chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
694 $_chroot $command $rc_flags $command_args"
695                         else
696                                 _doit="\
697 ${_chdir:+cd $_chdir && }\
698 $command $rc_flags $command_args"
699                                 if [ -n "$_user" ]; then
700                                     _doit="su -m $_user -c 'sh -c \"$_doit\"'"
701                                 fi
702                                 if [ -n "$_nice" ]; then
703                                         if [ -z "$_user" ]; then
704                                                 _doit="sh -c \"$_doit\""
705                                         fi      
706                                         _doit="nice -n $_nice $_doit"
707                                 fi
708                         fi
709
710                                         # run the full command
711                                         #
712                         if ! _run_rc_doit "$_doit"; then
713                                 warn "failed to start ${name}"
714                                 return 1
715                         fi
716
717                                         # finally, run postcmd
718                                         #
719                         _run_rc_postcmd
720                         ;;
721
722                 stop)
723                         if [ -z "$rc_pid" ]; then
724                                 [ -n "$rc_fast" ] && return 0
725                                 _run_rc_notrunning
726                                 return 1
727                         fi
728
729                         _run_rc_precmd || return 1
730
731                                         # send the signal to stop
732                                         #
733                         echo "Stopping ${name}."
734                         _doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
735                         _run_rc_doit "$_doit" || return 1
736
737                                         # wait for the command to exit,
738                                         # and run postcmd.
739                         wait_for_pids $rc_pid
740
741                         _run_rc_postcmd
742                         ;;
743
744                 reload)
745                         if [ -z "$rc_pid" ]; then
746                                 _run_rc_notrunning
747                                 return 1
748                         fi
749
750                         _run_rc_precmd || return 1
751
752                         _doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
753                         _run_rc_doit "$_doit" || return 1
754
755                         _run_rc_postcmd
756                         ;;
757
758                 restart)
759                                         # prevent restart being called more
760                                         # than once by any given script
761                                         #
762                         if ${_rc_restart_done:-false}; then
763                                 return 0
764                         fi
765                         _rc_restart_done=true
766
767                         _run_rc_precmd || return 1
768
769                         # run those in a subshell to keep global variables
770                         ( run_rc_command ${_rc_prefix}stop $rc_extra_args )
771                         ( run_rc_command ${_rc_prefix}start $rc_extra_args )
772                         _return=$?
773                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
774
775                         _run_rc_postcmd
776                         ;;
777
778                 poll)
779                         _run_rc_precmd || return 1
780                         if [ -n "$rc_pid" ]; then
781                                 wait_for_pids $rc_pid
782                         fi
783                         _run_rc_postcmd
784                         ;;
785
786                 rcvar)
787                         echo "# $name"
788                         if [ -n "$rcvar" ]; then
789                                 if checkyesno ${rcvar}; then
790                                         echo "${rcvar}=YES"
791                                 else
792                                         echo "${rcvar}=NO"
793                                 fi
794                         fi
795                         ;;
796
797                 *)
798                         rc_usage $_keywords
799                         ;;
800
801                 esac
802                 return $_return
803         done
804
805         echo 1>&2 "$0: unknown directive '$rc_arg'."
806         rc_usage $_keywords
807         # not reached
808 }
809
810 #
811 # Helper functions for run_rc_command: common code.
812 # They use such global variables besides the exported rc_* ones:
813 #
814 #       name           R/W
815 #       ------------------
816 #       _precmd         R
817 #       _postcmd        R
818 #       _return         W
819 #
820 _run_rc_precmd()
821 {
822         check_required_before "$rc_arg" || return 1
823
824         if [ -n "$_precmd" ]; then
825                 debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
826                 eval "$_precmd $rc_extra_args"
827                 _return=$?
828
829                 # If precmd failed and force isn't set, request exit.
830                 if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
831                         return 1
832                 fi
833         fi
834
835         check_required_after "$rc_arg" || return 1
836
837         return 0
838 }
839
840 _run_rc_postcmd()
841 {
842         if [ -n "$_postcmd" ]; then
843                 debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
844                 eval "$_postcmd $rc_extra_args"
845                 _return=$?
846         fi
847         return 0
848 }
849
850 _run_rc_doit()
851 {
852         debug "run_rc_command: doit: $*"
853         eval "$@"
854         _return=$?
855
856         # If command failed and force isn't set, request exit.
857         if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
858                 return 1
859         fi
860
861         return 0
862 }
863
864 _run_rc_notrunning()
865 {
866         local _pidmsg
867
868         if [ -n "$pidfile" ]; then
869                 _pidmsg=" (check $pidfile)."
870         else
871                 _pidmsg=
872         fi
873         echo 1>&2 "${name} not running?${_pidmsg}"
874 }
875
876 _run_rc_killcmd()
877 {
878         local _cmd
879
880         _cmd="kill -$1 $rc_pid"
881         if [ -n "$_user" ]; then
882                 _cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
883         fi
884         echo "$_cmd"
885 }
886
887 #
888 # run_rc_script file arg
889 #       Start the script `file' with `arg', and correctly handle the
890 #       return value from the script.  If `file' ends with `.sh', it's
891 #       sourced into the current environment.  If `file' appears to be
892 #       a backup or scratch file, ignore it.  Otherwise if it's
893 #       executable run as a child process.
894 #
895 run_rc_script()
896 {
897         _file=$1
898         _arg=$2
899         if [ -z "$_file" -o -z "$_arg" ]; then
900                 err 3 'USAGE: run_rc_script file arg'
901         fi
902
903         unset   name command command_args command_interpreter \
904                 extra_commands pidfile procname \
905                 rcvar required_dirs required_files required_vars
906         eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
907
908         case "$_file" in
909         /etc/rc.d/*.sh)                 # no longer allowed in the base
910                 warn "Ignoring old-style startup script $_file"
911                 ;;
912         *[~#]|*.OLD|*.bak|*.orig|*,v)   # scratch file; skip
913                 warn "Ignoring scratch file $_file"
914                 ;;
915         *)                              # run in subshell
916                 if [ -x $_file ]; then
917                         if [ -n "$rc_fast_and_loose" ]; then
918                                 set $_arg; . $_file
919                         else
920                                 ( trap "echo Script $_file interrupted; kill -QUIT $$" 3
921                                   trap "echo Script $_file interrupted; exit 1" 2
922                                   trap "echo Script $_file running" 29
923                                   set $_arg; . $_file )
924                         fi
925                 fi
926                 ;;
927         esac
928 }
929
930 #
931 # load_rc_config name
932 #       Source in the configuration file for a given name.
933 #
934 load_rc_config()
935 {
936         _name=$1
937         if [ -z "$_name" ]; then
938                 err 3 'USAGE: load_rc_config name'
939         fi
940
941         if ${_rc_conf_loaded:-false}; then
942                 :
943         else
944                 if [ -r /etc/defaults/rc.conf ]; then
945                         debug "Sourcing /etc/defaults/rc.conf"
946                         . /etc/defaults/rc.conf
947                         source_rc_confs
948                 elif [ -r /etc/rc.conf ]; then
949                         debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
950                         . /etc/rc.conf
951                 fi
952                 _rc_conf_loaded=true
953         fi
954         if [ -f /etc/rc.conf.d/"$_name" ]; then
955                 debug "Sourcing /etc/rc.conf.d/${_name}"
956                 . /etc/rc.conf.d/"$_name"
957         fi
958
959         # Old variable names support
960         #
961         [ -n "$enable_quotas" ] && quota_enable="$enable_quotas"
962 }
963   
964 #
965 # load_rc_config_var name var
966 #       Read the rc.conf(5) var for name and set in the
967 #       current shell, using load_rc_config in a subshell to prevent
968 #       unwanted side effects from other variable assignments.
969 #
970 load_rc_config_var()
971 {
972         if [ $# -ne 2 ]; then
973                 err 3 'USAGE: load_rc_config_var name var'
974         fi
975         eval $(eval '(
976                 load_rc_config '$1' >/dev/null;
977                 if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
978                         echo '$2'=\'\''${'$2'}\'\'';
979                 fi
980         )' )
981 }
982
983 #
984 # rc_usage commands
985 #       Print a usage string for $0, with `commands' being a list of
986 #       valid commands.
987 #
988 rc_usage()
989 {
990         echo -n 1>&2 "Usage: $0 [fast|force|one]("
991
992         _sep=
993         for _elem; do
994                 echo -n 1>&2 "$_sep$_elem"
995                 _sep="|"
996         done
997         echo 1>&2 ")"
998         exit 1
999 }
1000
1001 #
1002 # err exitval message
1003 #       Display message to stderr and log to the syslog, and exit with exitval.
1004 #
1005 err()
1006 {
1007         exitval=$1
1008         shift
1009
1010         if [ -x /usr/bin/logger ]; then
1011                 logger "$0: ERROR: $*"
1012         fi
1013         echo 1>&2 "$0: ERROR: $*"
1014         exit $exitval
1015 }
1016
1017 #
1018 # warn message
1019 #       Display message to stderr and log to the syslog.
1020 #
1021 warn()
1022 {
1023         if [ -x /usr/bin/logger ]; then
1024                 logger "$0: WARNING: $*"
1025         fi
1026         echo 1>&2 "$0: WARNING: $*"
1027 }
1028
1029 #
1030 # info message
1031 #       Display informational message to stdout and log to syslog.
1032 #
1033 info()
1034 {
1035         case ${rc_info} in
1036         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1037                 if [ -x /usr/bin/logger ]; then
1038                         logger "$0: INFO: $*"
1039                 fi
1040                 echo "$0: INFO: $*"
1041                 ;;
1042         esac
1043 }
1044
1045 #
1046 # debug message
1047 #       If debugging is enabled in rc.conf output message to stderr.
1048 #       BEWARE that you don't call any subroutine that itself calls this
1049 #       function.
1050 #
1051 debug()
1052 {
1053         case ${rc_debug} in
1054         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1055                 if [ -x /usr/bin/logger ]; then
1056                         logger "$0: DEBUG: $*"
1057                 fi
1058                 echo 1>&2 "$0: DEBUG: $*"
1059                 ;;
1060         esac
1061 }
1062
1063 #
1064 # backup_file action file cur backup
1065 #       Make a backup copy of `file' into `cur', and save the previous
1066 #       version of `cur' as `backup' or use rcs for archiving.
1067 #
1068 #       This routine checks the value of the backup_uses_rcs variable,
1069 #       which can be either YES or NO.
1070 #
1071 #       The `action' keyword can be one of the following:
1072 #
1073 #       add             `file' is now being backed up (and is possibly
1074 #                       being reentered into the backups system).  `cur'
1075 #                       is created and RCS files, if necessary, are
1076 #                       created as well.
1077 #
1078 #       update          `file' has changed and needs to be backed up.
1079 #                       If `cur' exists, it is copied to to `back' or
1080 #                       checked into RCS (if the repository file is old),
1081 #                       and then `file' is copied to `cur'.  Another RCS
1082 #                       check in done here if RCS is being used.
1083 #
1084 #       remove          `file' is no longer being tracked by the backups
1085 #                       system.  If RCS is not being used, `cur' is moved
1086 #                       to `back', otherwise an empty file is checked in,
1087 #                       and then `cur' is removed.
1088 #
1089 #
1090 backup_file()
1091 {
1092         _action=$1
1093         _file=$2
1094         _cur=$3
1095         _back=$4
1096
1097         if checkyesno backup_uses_rcs; then
1098                 _msg0="backup archive"
1099                 _msg1="update"
1100
1101                 # ensure that history file is not locked
1102                 if [ -f $_cur,v ]; then
1103                         rcs -q -u -U -M $_cur
1104                 fi
1105
1106                 # ensure after switching to rcs that the
1107                 # current backup is not lost
1108                 if [ -f $_cur ]; then
1109                         # no archive, or current newer than archive
1110                         if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1111                                 ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1112                                 rcs -q -kb -U $_cur
1113                                 co -q -f -u $_cur
1114                         fi
1115                 fi
1116
1117                 case $_action in
1118                 add|update)
1119                         cp -p $_file $_cur
1120                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1121                         rcs -q -kb -U $_cur
1122                         co -q -f -u $_cur
1123                         chown root:wheel $_cur $_cur,v
1124                         ;;
1125                 remove)
1126                         cp /dev/null $_cur
1127                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1128                         rcs -q -kb -U $_cur
1129                         chown root:wheel $_cur $_cur,v
1130                         rm $_cur
1131                         ;;
1132                 esac
1133         else
1134                 case $_action in
1135                 add|update)
1136                         if [ -f $_cur ]; then
1137                                 cp -p $_cur $_back
1138                         fi
1139                         cp -p $_file $_cur
1140                         chown root:wheel $_cur
1141                         ;;
1142                 remove)
1143                         mv -f $_cur $_back
1144                         ;;
1145                 esac
1146         fi
1147 }
1148
1149 # make_symlink src link
1150 #       Make a symbolic link 'link' to src from basedir. If the
1151 #       directory in which link is to be created does not exist
1152 #       a warning will be displayed and an error will be returned.
1153 #       Returns 0 on sucess, 1 otherwise.
1154 #
1155 make_symlink()
1156 {
1157         local src link linkdir _me
1158         src="$1"
1159         link="$2"
1160         linkdir="`dirname $link`"
1161         _me="make_symlink()"
1162
1163         if [ -z "$src" -o -z "$link" ]; then
1164                 warn "$_me: requires two arguments."
1165                 return 1
1166         fi
1167         if [ ! -d "$linkdir" ]; then
1168                 warn "$_me: the directory $linkdir does not exist."
1169                 return 1
1170         fi
1171         if ! ln -sf $src $link; then
1172                 warn "$_me: unable to make a symbolic link from $link to $src"
1173                 return 1
1174         fi
1175         return 0
1176 }
1177
1178 # devfs_rulesets_from_file file
1179 #       Reads a set of devfs commands from file, and creates
1180 #       the specified rulesets with their rules. Returns non-zero
1181 #       if there was an error.
1182 #
1183 devfs_rulesets_from_file()
1184 {
1185         local file _err _me
1186         file="$1"
1187         _me="devfs_rulesets_from_file"
1188         _err=0
1189
1190         if [ -z "$file" ]; then
1191                 warn "$_me: you must specify a file"
1192                 return 1
1193         fi
1194         if [ ! -e "$file" ]; then
1195                 debug "$_me: no such file ($file)"
1196                 return 0
1197         fi
1198         debug "reading rulesets from file ($file)"
1199         { while read line
1200         do
1201                 case $line in
1202                 \#*)
1203                         continue
1204                         ;;
1205                 \[*\]*)
1206                         rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1207                         if [ -z "$rulenum" ]; then
1208                                 warn "$_me: cannot extract rule number ($line)"
1209                                 _err=1
1210                                 break
1211                         fi
1212                         rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1213                         if [ -z "$rulename" ]; then
1214                                 warn "$_me: cannot extract rule name ($line)"
1215                                 _err=1
1216                                 break;
1217                         fi
1218                         eval $rulename=\$rulenum
1219                         debug "found ruleset: $rulename=$rulenum"
1220                         if ! /sbin/devfs rule -s $rulenum delset; then
1221                                 _err=1
1222                                 break
1223                         fi
1224                         ;;
1225                 *)
1226                         rulecmd="${line%%"\#*"}"
1227                         # evaluate the command incase it includes
1228                         # other rules
1229                         if [ -n "$rulecmd" ]; then
1230                                 debug "adding rule ($rulecmd)"
1231                                 if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1232                                 then
1233                                         _err=1
1234                                         break
1235                                 fi
1236                         fi
1237                         ;;
1238                 esac
1239                 if [ $_err -ne 0 ]; then
1240                         debug "error in $_me"
1241                         break
1242                 fi
1243         done } < $file
1244         return $_err
1245 }
1246
1247 # devfs_init_rulesets
1248 #       Initializes rulesets from configuration files. Returns
1249 #       non-zero if there was an error.
1250 #
1251 devfs_init_rulesets()
1252 {
1253         local file _me
1254         _me="devfs_init_rulesets"
1255
1256         # Go through this only once
1257         if [ -n "$devfs_rulesets_init" ]; then
1258                 debug "$_me: devfs rulesets already initialized"
1259                 return
1260         fi
1261         for file in $devfs_rulesets; do
1262                 devfs_rulesets_from_file $file || return 1
1263         done
1264         devfs_rulesets_init=1
1265         debug "$_me: devfs rulesets initialized"
1266         return 0
1267 }
1268
1269 # devfs_set_ruleset ruleset [dir]
1270 #       Sets the default ruleset of dir to ruleset. The ruleset argument
1271 #       must be a ruleset name as specified in devfs.rules(5) file.
1272 #       Returns non-zero if it could not set it successfully.
1273 #
1274 devfs_set_ruleset()
1275 {
1276         local devdir rs _me
1277         [ -n "$1" ] && eval rs=\$$1 || rs=
1278         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1279         _me="devfs_set_ruleset"
1280
1281         if [ -z "$rs" ]; then
1282                 warn "$_me: you must specify a ruleset number"
1283                 return 1
1284         fi
1285         debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1286         if ! /sbin/devfs $devdir ruleset $rs; then
1287                 warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1288                 return 1
1289         fi
1290         return 0
1291 }
1292
1293 # devfs_apply_ruleset ruleset [dir]
1294 #       Apply ruleset number $ruleset to the devfs mountpoint $dir.
1295 #       The ruleset argument must be a ruleset name as specified
1296 #       in a devfs.rules(5) file.  Returns 0 on success or non-zero
1297 #       if it could not apply the ruleset.
1298 #
1299 devfs_apply_ruleset()
1300 {
1301         local devdir rs _me
1302         [ -n "$1" ] && eval rs=\$$1 || rs=
1303         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1304         _me="devfs_apply_ruleset"
1305
1306         if [ -z "$rs" ]; then
1307                 warn "$_me: you must specify a ruleset"
1308                 return 1
1309         fi
1310         debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1311         if ! /sbin/devfs $devdir rule -s $rs applyset; then
1312                 warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1313                 return 1
1314         fi
1315         return 0
1316 }
1317
1318 # devfs_domount dir [ruleset]
1319 #       Mount devfs on dir. If ruleset is specified it is set
1320 #       on the mount-point. It must also be a ruleset name as specified
1321 #       in a devfs.rules(5) file. Returns 0 on success.
1322 #
1323 devfs_domount()
1324 {
1325         local devdir rs _me
1326         devdir="$1"
1327         [ -n "$2" ] && rs=$2 || rs=
1328         _me="devfs_domount()"
1329
1330         if [ -z "$devdir" ]; then
1331                 warn "$_me: you must specify a mount-point"
1332                 return 1
1333         fi
1334         debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1335         if ! mount -t devfs dev "$devdir"; then
1336                 warn "$_me: Unable to mount devfs on $devdir"
1337                 return 1
1338         fi
1339         if [ -n "$rs" ]; then
1340                 devfs_init_rulesets
1341                 devfs_set_ruleset $rs $devdir
1342                 devfs -m $devdir rule applyset
1343         fi
1344         return 0
1345 }
1346
1347 # devfs_mount_jail dir [ruleset]
1348 #       Mounts a devfs file system appropriate for jails
1349 #       on the directory dir. If ruleset is specified, the ruleset
1350 #       it names will be used instead.  If present, ruleset must
1351 #       be the name of a ruleset as defined in a devfs.rules(5) file.
1352 #       This function returns non-zero if an error occurs.
1353 #
1354 devfs_mount_jail()
1355 {
1356         local jdev rs _me
1357         jdev="$1"
1358         [ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1359         _me="devfs_mount_jail"
1360
1361         devfs_init_rulesets
1362         if ! devfs_domount "$jdev" $rs; then
1363                 warn "$_me: devfs was not mounted on $jdev"
1364                 return 1
1365         fi
1366         return 0
1367 }
1368
1369 # Provide a function for normalizing the mounting of memory
1370 # filesystems.  This should allow the rest of the code here to remain
1371 # as close as possible between 5-current and 4-stable.
1372 #   $1 = size
1373 #   $2 = mount point
1374 #   $3 = (optional) extra mdmfs flags
1375 mount_md()
1376 {
1377         if [ -n "$3" ]; then
1378                 flags="$3"
1379         fi
1380         /sbin/mdmfs $flags -s $1 md $2
1381 }
1382
1383 # Code common to scripts that need to load a kernel module
1384 # if it isn't in the kernel yet. Syntax:
1385 #   load_kld [-e regex] [-m module] file
1386 # where -e or -m chooses the way to check if the module
1387 # is already loaded:
1388 #   regex is egrep'd in the output from `kldstat -v',
1389 #   module is passed to `kldstat -m'.
1390 # The default way is as though `-m file' were specified.
1391 load_kld()
1392 {
1393         local _loaded _mod _opt _re
1394
1395         while getopts "e:m:" _opt; do
1396                 case "$_opt" in
1397                 e) _re="$OPTARG" ;;
1398                 m) _mod="$OPTARG" ;;
1399                 *) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1400                 esac
1401         done
1402         shift $(($OPTIND - 1))
1403         if [ $# -ne 1 ]; then
1404                 err 3 'USAGE: load_kld [-e regex] [-m module] file'
1405         fi
1406         _mod=${_mod:-$1}
1407         _loaded=false
1408         if [ -n "$_re" ]; then
1409                 if kldstat -v | egrep -q -e "$_re"; then
1410                         _loaded=true
1411                 fi
1412         else
1413                 if kldstat -q -m "$_mod"; then
1414                         _loaded=true
1415                 fi
1416         fi
1417         if ! $_loaded; then
1418                 if ! kldload "$1"; then
1419                         warn "Unable to load kernel module $1"
1420                         return 1
1421                 else
1422                         info "$1 kernel module loaded."
1423                 fi
1424         else
1425                 debug "load_kld: $1 kernel module already loaded."
1426         fi
1427         return 0
1428 }
1429
1430 # ltr str src dst
1431 #       Change every $src in $str to $dst.
1432 #       Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1433 #       awk(1).
1434 ltr()
1435 {
1436         local _str _src _dst _out _com
1437         _str=$1
1438         _src=$2
1439         _dst=$3
1440         _out=""
1441
1442         IFS=${_src}
1443         for _com in ${_str}; do
1444                 if [ -z "${_out}" ]; then
1445                         _out="${_com}"
1446                 else
1447                         _out="${_out}${_dst}${_com}"
1448                 fi
1449         done
1450         echo "${_out}"
1451 }
1452
1453 # Creates a list of providers for GELI encryption.
1454 geli_make_list()
1455 {
1456         local devices devices2
1457         local provider mountpoint type options rest
1458
1459         # Create list of GELI providers from fstab.
1460         while read provider mountpoint type options rest ; do
1461                 case ":${options}" in
1462                 :*noauto*)
1463                         noauto=yes
1464                         ;;
1465                 *)
1466                         noauto=no
1467                         ;;
1468                 esac
1469
1470                 case ":${provider}" in
1471                 :#*)
1472                         continue
1473                         ;;
1474                 *.eli)
1475                         # Skip swap devices.
1476                         if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1477                                 continue
1478                         fi
1479                         devices="${devices} ${provider}"
1480                         ;;
1481                 esac
1482         done < /etc/fstab
1483
1484         # Append providers from geli_devices.
1485         devices="${devices} ${geli_devices}"
1486
1487         for provider in ${devices}; do
1488                 provider=${provider%.eli}
1489                 provider=${provider#/dev/}
1490                 devices2="${devices2} ${provider}"
1491         done
1492
1493         echo ${devices2}
1494 }
1495
1496 # Find scripts in local_startup directories that use the old syntax
1497 #
1498 find_local_scripts_old () {
1499         zlist=''
1500         slist=''
1501         for dir in ${local_startup}; do
1502                 if [ -d "${dir}" ]; then
1503                         for file in ${dir}/[0-9]*.sh; do
1504                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1505                                     continue
1506                                 zlist="$zlist $file"
1507                         done
1508                         for file in ${dir}/[^0-9]*.sh; do
1509                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1510                                     continue
1511                                 slist="$slist $file"
1512                         done
1513                 fi
1514         done
1515 }
1516
1517 find_local_scripts_new () {
1518         local_rc=''
1519         for dir in ${local_startup}; do
1520                 if [ -d "${dir}" ]; then
1521                         for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1522                                 case "$file" in
1523                                 *.sample) ;;
1524                                 *)      if [ -x "$file" ]; then
1525                                                 local_rc="${local_rc} ${file}"
1526                                         fi
1527                                         ;;
1528                                 esac
1529                         done
1530                 fi
1531         done
1532 }
1533
1534 # check_required_{before|after} command
1535 #       Check for things required by the command before and after its precmd,
1536 #       respectively.  The two separate functions are needed because some
1537 #       conditions should prevent precmd from being run while other things
1538 #       depend on precmd having already been run.
1539 #
1540 check_required_before()
1541 {
1542         local _f
1543
1544         case "$1" in
1545         start)
1546                 for _f in $required_vars; do
1547                         if ! checkyesno $_f; then
1548                                 warn "\$${_f} is not enabled."
1549                                 if [ -z "$rc_force" ]; then
1550                                         return 1
1551                                 fi
1552                         fi
1553                 done
1554
1555                 for _f in $required_dirs; do
1556                         if [ ! -d "${_f}/." ]; then
1557                                 warn "${_f} is not a directory."
1558                                 if [ -z "$rc_force" ]; then
1559                                         return 1
1560                                 fi
1561                         fi
1562                 done
1563
1564                 for _f in $required_files; do
1565                         if [ ! -r "${_f}" ]; then
1566                                 warn "${_f} is not readable."
1567                                 if [ -z "$rc_force" ]; then
1568                                         return 1
1569                                 fi
1570                         fi
1571                 done
1572                 ;;
1573         esac
1574
1575         return 0
1576 }
1577
1578 check_required_after()
1579 {
1580         local _f _args
1581
1582         case "$1" in
1583         start)
1584                 for _f in $required_modules; do
1585                         case "${_f}" in
1586                                 *~*)    _args="-e ${_f#*~} ${_f%%~*}" ;;
1587                                 *:*)    _args="-m ${_f#*:} ${_f%%:*}" ;;
1588                                 *)      _args="${_f}" ;;
1589                         esac
1590                         if ! load_kld ${_args}; then
1591                                 if [ -z "$rc_force" ]; then
1592                                         return 1
1593                                 fi
1594                         fi
1595                 done
1596                 ;;
1597         esac
1598
1599         return 0
1600 }
1601
1602 fi
1603
1604 _rc_subr_loaded=: